﻿
$(function () {
    if (isPC()) {//解决PC端一像素边框的问题
        $("#base").after('<link id="base" href="../resources/css/map.border.css" rel="stylesheet" type="text/css" />')
    }

    $("#txt_name").focus();

    $("#txt_name").on("input propertychange", poiTxtChangeHndler);
    $("#txt_point_type").click(function (evt) {
        $("#content_type").hide();
        $("#content_history").hide();
        $("#content_list").hide();

        $("#content_point_type").show();
    });


    $("#point_type_this").click(function (evt) {
        $("#radius_content").show();
        $("#txt_point_type").val("目前位置");
        $("#txt_point_type_value").val("1");

        poiTxtChangeHndler();
    });
    $("#point_type_extent").click(function (evt) {
        $("#radius_content").hide();
        $("#txt_point_type").val("当前视域");
        $("#txt_point_type_value").val("2");

        poiTxtChangeHndler();
    });
    $("#point_type_select").click(function (evt) {
        $("#radius_content").show();
        $("#txt_point_type").val("图上选点");
        $("#txt_point_type_value").val("3");
        parent.workTSXD.startTsxd();
    });

    if (parent.workZBCX.hasData())
        $("#footer_clear").show();
    else
        $("#footer_clear").hide();

    $("#footer_clear").click(function (evt) {
        $("#footer_clear").hide();
        parent.workZBCX.clear();
        $("#txt_name").val("");
        poiTxtChangeHndler();
        parent.hideExPage();
    });

    $("#sel_radius").val("-1");//默认值

    showHistoryList();
});

var lastPoint;
function endSelectMpt(latlng) {
    lastPoint = latlng;
    $("#txt_point_type").val("位置(" + latlng.lng.toFixed(4) + "," + latlng.lat.toFixed(4) + ")");
    poiTxtChangeHndler();
}

function clearQueryText() {
    $("#txt_name").val("");
    poiTxtChangeHndler();
}


var timeInv = -1;
function poiTxtChangeHndler() { 
    if (timeInv > 0) {
        clearTimeout(timeInv);
        timeInv = -1;
    }
    timeInv = setTimeout(startQuery, 500);
}
 


function startQuery() { 
    timeInv = -1;

    $("#content_point_type").hide();
      
    //文本框内容为空
    var txtval = $.trim($("#txt_name").val());
    if (txtval.length > 0) { 
        $("#content_history").hide();
        $("#content_list").show();

        var radius = Number($("#sel_radius").val());
        var type = $("#txt_point_type_value").val();
        var param = { text: txtval, type: type, radius: radius };
        if (type == "3")
            param.latlng = lastPoint;

        $("#ul_poi_list").html("");
        parent.workZBCX.queryDZ(param, poiQueryResult);
    }
    else {
        parent.workZBCX.clear();
         
        $("#content_history").show();
        $("#content_list").hide();
        showHistoryList();
    } 
}



var lastObjData = {};
function poiQueryResult(arrdata, objdata) {
    if (arrdata == null || arrdata.length == 0) {
        var txtval = $.trim($("#txt_name").val());
        var radius = Number($("#sel_radius").val());
        var type = $("#txt_point_type").val();
        if (radius > 0 && type != "当前视域") {
            type += "" + formatLength(radius) + "内";
        }
        $("#ul_poi_list").html("<li>在" + type + "没有查询到“" + txtval + "”相关记录!</li>");
        return;
    }
    lastObjData = objdata; 
    workQueryPOI.showResult(arrdata);

    $("#footer_clear").show();
}



//显示查询结果处理
var workQueryPOI = {
    pageSize: 10,
    arrdata: [],
    counts: 0,
    allpage: 0,
    thispage: 0,
    showResult: function (data) {
        this.pageSize = Math.floor((window.innerHeight - 110) / 50) - 3;
        if (this.pageSize < 5)
            this.pageSize = 5;

        this.arrdata = data;
        this.counts = data.length;
        this.allpage = Math.ceil(this.counts / this.pageSize);
        this.thispage = 1;
        this.showPOIPage();
    },
    showPOIPage: function () {
        var inhtml = "";

        var startIdx = (this.thispage - 1) * this.pageSize;
        var endIdx = startIdx + this.pageSize;
        if (endIdx >= this.counts) {
            endIdx = this.counts;
        }

        //分页信息
        inhtml += '<li style="height: 30px;padding:20px 5px 5px 5px;"><div class="querybar-page"><div class="querybar-fl">找到<strong>'
            + this.counts + '</strong>条结果</div><div class="querybar-ye querybar-fr">'
            + this.thispage + '/' + this.allpage + '页  <a href="javascript:workQueryPOI.showFirstPage()">首页</a> <a href="javascript:workQueryPOI.showPretPage()">上一页</a>  <a href="javascript:workQueryPOI.showNextPage()">下一页</a> </div></div></li>';


        for (var index = startIdx; index < endIdx; index++) {
            var item = this.arrdata[index];

            var name = item.NAME;
            if (name.length > 15)
                name = name.substring(0, 15) + "...";

            var address = item.ADDRESS;
            if (address.length > 22)
                address = address.substring(0, 22) + "...";

            inhtml += '<li  onclick="showpoi(\'' + item.OBJECTID + '\')" ><i class="icon_left"></i><h2  >'
                        + (index + 1) + '.' + name + '</h2><p>' + address
                        + '</p><i class="icon_right"  onclick="showpoi_route(\'' + item.OBJECTID + '\')"></i></li>';
        };

        $("#ul_poi_list").html(inhtml);
    },
    showFirstPage: function () {
        this.thispage = 1;
        this.showPOIPage();
    },
    showNextPage: function () {
        this.thispage = this.thispage + 1;
        if (this.thispage > this.allpage)
            this.thispage = this.allpage;
        this.showPOIPage();
    },

    showPretPage: function () {
        this.thispage = this.thispage - 1;
        if (this.thispage < 1)
            this.thispage = 1;
        this.showPOIPage();
    }

};

function showpoi(id) {
    var data = lastObjData[id];

    addHistory(data.NAME);

    parent.workZBCX.clear();
    parent.workZBCX.showPOI(data, true);
    parent.hideExPage();
}

function showpoi_route(id) {
    var data = lastObjData[id];
    parent.workZBCX._poidata = data;
    parent.workZBCX.getPoiInfoLX();

    parent.hideExPage();
}
 
function showhistorypoi(text) {
    $("#txt_name").val(text);
    poiTxtChangeHndler();
}



//历史记录
var historyListCount = 0;
var cookieName = 'yhapp_dz';

var arrHistory = [];
function showHistoryList() {
    $("#content_history").hide();

    var lastcookie = parent.getCookie(cookieName); //读取cookie值  
    if (lastcookie == null) return;

    arrHistory = eval(lastcookie);
    if (arrHistory == null || arrHistory.length == 0) return;

    var inhtml = "";
    for (var index = arrHistory.length - 1; index >= 0 ; index--) {
        var item = arrHistory[index];
        inhtml += " <li onclick=\"showhistorypoi('" + item + "')\"><span>" + item + "</span></li>";
    }
    inhtml += "<li onclick=\"clearHistory()\"><span>清空历史记录</span></li>";
    $("#historyul").html(inhtml);

    $("#content_history").show();
}

function clearHistory() {
    arrHistory = [];
    parent.deleteCookie(cookieName);
    $("#historyul").html("");
    $("#content_history").hide();
}

//记录历史值 
function addHistory(data) {
    arrHistory = [];
    var lastcookie = parent.getCookie(cookieName); //读取cookie值  
    if (lastcookie != null) {
        arrHistory = eval(lastcookie);
    }
    //先删除之前相同记录
    arrHistory.remove(data);

    arrHistory.push(data);

    if (arrHistory.length > 10)
        arrHistory.splice(0, 1);

    lastcookie = JSON.stringify(arrHistory);
    parent.addCookie(cookieName, lastcookie);
}
