﻿//常用通用方法js
//创建：汪浩（qq :346819890） 2016-11-18

//扩展array数组方法
Array.prototype.indexOf = function(val) {
	for(var i = 0; i < this.length; i++) {
		if(this[i] == val) return i;
	}
	return -1;
};
Array.prototype.remove = function(val) {
	var index = this.indexOf(val);
	if(index > -1) {
		this.splice(index, 1);
	}
};

//随机数组中随机取1个元素
function getRandomArrayOne(arr) {
    var n = Math.floor(Math.random() * arr.length + 1) - 1;
    return arr[n];
}

//格式化距离长度
function formatLength(strlen) {
	var numlen = Number(strlen);

	if(numlen < 1000)
		return numlen + "米";
	else
		return(numlen / 1000).toFixed(1) + "公里";
}

//格式化时间
function formatTime(strtime) {
	var numtime = Number(strtime);

	if(strtime < 60)
		return strtime + "秒";
	else if(strtime >= 60 && strtime < 3600)
		return(strtime / 60).toFixed(0) + "分钟"
	else
		return(strtime / 3600).toFixed(1) + "小时"
}

function getNowStr() {
	var date = new Date();
	var year = date.getFullYear();
	var month = date.getMonth() + 1;
	var day = date.getDate();
	var hour = date.getHours();
	var minute = date.getMinutes();
	var second = date.getSeconds();
	return year + '_' + month + '_' + day + '_' + hour+ '_' + minute + '_' + second; 
}

//添加cookie 
function addCookie(name, value, days) {
    
	var date;
	if (days > 0) {
	    date = new Date();
	    date.setTime(date.getTime + days * 24 * 60 * 60 * 1000); //单位是天后失效
	}
	else {
	    date = new Date(0x7fffffff * 1e3);
	} 
	var cookieString = name + "=" + escape(value)+  "; expires=" + date.toGMTString();


	if(isPC()) {
		document.cookie = cookieString;
	} else {
		plus.navigator.setCookie(name, cookieString);
		console.log('setCookie:' + cookieString);
	}
}

//获取cookie
function getCookie(name) {
	var strCookie
	if(isPC()) {
		strCookie = document.cookie;

	} else {
		strCookie = plus.navigator.getCookie(name);
		if(strCookie == null) return null;
		console.log('getCookie:' + strCookie);
	}

	var arrCookie = strCookie.split("; ");
	for(var i = 0; i < arrCookie.length; i++) {
		var arr = arrCookie[i].split("=");
		if(arr[0] == name) {
			return unescape(arr[1]);
		}
	}
	return null;
}

//删除cookie
function deleteCookie(name) {
	if(isPC()) {
		var date = new Date();
		date.setTime(date.getTime() - 10000); //设定一个过去的时间即可
		document.cookie = name + "=v; expires=" + date.toGMTString();
	} else {
		plus.navigator.removeCookie(name);
	}
}

//url参数获取
function getRequest() {
	var url = location.search; //获取url中"?"符后的字串   
	var theRequest = new Object();
	if(url.indexOf("?") != -1) {
		var str = url.substr(1);
		strs = str.split("&");
		for(var i = 0; i < strs.length; i++) {
			theRequest[strs[i].split("=")[0]] = decodeURI(strs[i].split("=")[1]);
		}
	}
	return theRequest;
}

function getQueryString(name) {
	var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
	var r = window.location.search.substr(1).match(reg);
	if(r != null) return decodeURI(r[2]);
	return null;
}

//浏览器
function isPC() {
	var sUserAgent = navigator.userAgent.toLowerCase();

	var bIsIpad = sUserAgent.match(/ipad/i) == "ipad";
	var bIsIphoneOs = sUserAgent.match(/iphone/i) == "iphone";
	var bIsMidp = sUserAgent.match(/midp/i) == "midp";
	var bIsUc7 = sUserAgent.match(/rv:1.2.3.4/i) == "rv:1.2.3.4";
	var bIsUc = sUserAgent.match(/ucweb/i) == "ucweb";
	var bIsAndroid = sUserAgent.match(/android/i) == "android";
	var bIsCE = sUserAgent.match(/windows ce/i) == "windows ce";
	var bIsWM = sUserAgent.match(/windows mobile/i) == "windows mobile";
	if(bIsIpad || bIsIphoneOs || bIsMidp || bIsUc7 || bIsUc || bIsAndroid || bIsCE || bIsWM) {
		return false;
	} else {
		return true;
	}
}

//判断字符是否是中文字符 
function isChinese(s) {
	var patrn = /[\u4E00-\u9FA5]|[\uFE30-\uFFA0]/gi;
	if(!patrn.exec(s)) {
		return false;
	} else {
		return true;
	}
}

//随机颜色
function getRandomColor() {
    return '#' +

      (function (color) {

          return (color += '0123456789abcdef'[Math.floor(Math.random() * 16)]) && (color.length == 6) ? color : arguments.callee(color);

      })('');
}