﻿
//============================标注绘制================================ 
var drawWidget = (function () {
    //单例对象
    var instantiated;
    function init() {
        return {
            plotLayer: null,
            drawControl: null,
            textControl: null,
            create: function () {
                this.plotLayer = new L.FeatureGroup();
                this.plotLayer.on('click', this._plotLayer_clickHndler, this);

                var options = {
                    position: 'bottomright',
                    draw: {
                        polyline: {
                            shapeOptions: {
                                color: '#0000ff',
                                weight: 4
                            }
                        },
                        polygon: {
                            allowIntersection: false,
                            showArea: true,
                            shapeOptions: {
                                color: '#0000ff',
                                weight: 2
                            }
                        },
                        rectangle: {
                            shapeOptions: {
                                color: '#0000ff',
                                weight: 2
                            }
                        },
                        circle: {
                            shapeOptions: {
                                color: '#0000ff',
                                weight: 2
                            }
                        }
                    },
                    edit: {
                        featureGroup: this.plotLayer,
                        remove: true
                    }
                };
                this.drawControl = new L.Control.Draw(options);


                //标注文本
                L.DrawTextControl = L.MuyaoControl.extend({
                    options: {
                        position: 'bottomright',
                        innerHTML: '字',
                        title: '创建文本标记',
                        callback: function (options) {
                            map.on('click', options._mapClick_handler, options);
                        },
                        _mapClick_handler: function (e) {
                            map.off('click', this._mapClick_handler, this);

                            var mark = L.marker(e.latlng, { icon: L.icon({ iconUrl: 'resources/lib/leaflet/plugins/label/img/null.png' }) });
                            mark.type = "text";
                            mark.text = "文字";
                            drawWidget.Instance().plotLayer.addLayer(mark);
                            mark.bindLabel(mark.text, { direction: 'center', permanent: true, interactive: true });
                        }
                    }
                });
                this.textControl = new L.DrawTextControl();
            },
            //激活状态
            isactivate: false,
            //激活工具
            activate: function () {
                this.isactivate = true;
                hideUIView();
                $("#content_header_tipbar").show();
                $("#tipbar_text").html("绘图板");
                $("#tipbar_back").bind("click", this.disable);

                var $tipbarbtn = $("#tipbar_btn");
                $tipbarbtn.html("截屏分享");
                $tipbarbtn.show();
                $tipbarbtn.bind("click", this._save_image);

                map.addLayer(this.plotLayer);
                map.addControl(this.drawControl);
                map.addControl(this.textControl);
                map.on(L.Draw.Event.CREATED, this._draw_createdHandler);
                map.on("click", this._hide_update_mark_view);
            },
            disable: function () {
                var $this = drawWidget.Instance();
                if (!$this.isactivate) return;
                $this.isactivate = false;

                $("#tipbar_back").unbind("click", $this.disable);
                showUIView();
                $("#content_header_tipbar").hide();

                var $tipbarbtn = $("#tipbar_btn");
                $tipbarbtn.hide();
                $tipbarbtn.unbind("click", $this._save_image);

                map.removeLayer($this.plotLayer);
                map.removeControl($this.drawControl);
                map.removeControl($this.textControl);
                map.off(L.Draw.Event.CREATED, $this._draw_createdHandler);
                map.off("click", $this._hide_update_mark_view);
            },
            _draw_createdHandler: function (e) {
                var type = e.layerType,
                    layer = e.layer;

                drawWidget.Instance().plotLayer.addLayer(layer);
            },
            _last_sel_mark: null,
            _plotLayer_clickHndler: function (e) {
                $("#content_plot_info").hide(100);

                var mark = e.layer;
                if (mark != null && mark.type == "text") {
                    // 
                    $("#content_plot_info").show(100);
                    $("#txt_plot_name").val(mark.text);
                    this._last_sel_mark = mark;
                }
            },
            _hide_update_mark_view: function () {
                $("#content_plot_info").hide(100);
            },
            update_mark_info: function () {
                var mark = this._last_sel_mark;
                if (mark == null) return;

                var text = $.trim($("#txt_plot_name").val());
                if (text.length == 0) text = "文字";

                mark.text = text;  //unbindLabel
                mark.bindLabel(mark.text, { direction: 'center', permanent: true, interactive: true });
                $("#content_plot_info").hide(100);
            },
            _save_image: function () {
                //截屏
                shareWeiXin();
            }

        };
    }

    return {
        Instance: function () {
            if (!instantiated) {
                instantiated = init();
                instantiated.create();
            }
            return instantiated;
        }
    };
})();