﻿
//============================规划统计功能================================ 
var workGHTJ = {
    layerDraw: null,
    polygon: null,
    layerResult: null,
    create: function () {
        this.layerDraw = new L.FeatureGroup();
        this.layerResult = new L.FeatureGroup();
        map.addLayer(this.layerResult);
    },
    //激活状态
    isactivate: false,
    //激活工具
    activate: function () {
        this.isactivate = true;

        if (this.layerDraw == null)
            this.create();

        hideUIView();
        $("#content_header_tipbar").show();
        $("#tipbar_text").html("规划统计");
        $("#tipbar_back").bind("click", this.disable);

        var $tipbarbtn = $("#tipbar_btn");
        $tipbarbtn.html("统计");
        $tipbarbtn.show();
        $tipbarbtn.bind("click", this._queryTJ);


        var $tipbarbtn2 = $("#tipbar_btn2");
        $tipbarbtn2.html("框选");
        $tipbarbtn2.show();
        $tipbarbtn2.bind("click", this._resetDraw);


        map.addLayer(this.layerDraw);


        this.polygon = new L.Polygon([], {
            color: '#0000ff',
            weight: 1.5
        });
        this.layerDraw.addLayer(this.polygon);

        this.clearResult();

        map.on('click', this._onMapClick);
        //map.on('dblclick', this._onMapDoubleClick);
    },
    clearResult: function () {
        this._queryResultLast = null;
        if (this.layerResult)
            this.layerResult.clearLayers();
    },
    disable: function () {
        var $this = workGHTJ;

        if (!$this.isactivate) return;
        $this.isactivate = false;

        $("#tipbar_back").unbind("click", $this.disable);
        showUIView();
        $("#content_header_tipbar").hide();

        var $tipbarbtn = $("#tipbar_btn");
        $tipbarbtn.hide();
        $tipbarbtn.unbind("click", $this._queryTJ);

        var $tipbarbtn2 = $("#tipbar_btn2");
        $tipbarbtn2.hide();
        $tipbarbtn2.unbind("click", $this._resetDraw);


        $this.layerDraw.clearLayers();
        map.removeLayer($this.layerDraw);

        map.off('click', $this._onMapClick);
    },
    _onMapClick: function (e) {
        workGHTJ.updateDraw(e.latlng);
    },
    updateDraw: function (latlng) {
        this.polygon.addLatLng(latlng);
        this.polygon.redraw();

        var area = L.GeometryUtil.areastr(this.polygon.getLatLngs()[0]);
        $("#tipbar_text").html("规划统计 " + area);
    },
    _resetDraw: function () {
        var $this = workGHTJ;

        $this.polygon.setLatLngs([]);
        $this.polygon.redraw();
        $("#tipbar_text").html("规划统计 ");
    },
    _queryResultLast: null,
    _queryTJ: function () {
        var $this = workGHTJ;
        $this.layerResult.clearLayers();

        var poly = workGHTJ.polygon;
        if (poly.getLatLngs().length == 0) {
            showMsg("请框选一个范围！");
            return;
        }

        //查询  
        var _query = L.esri.query({
            url: gisdata.config.yhserver.gh_tj
        });
        _query.intersects(poly.toGeoJSON());

        showLoading({ text: '正在分析统计数据......' });
        _query.run(function (error, featureCollection, response) {
            hideLoading();
            var $this = workGHTJ;

            if (error != null && error.code > 0) {
                showMsg(error.message);
                return;
            }

            var layerJson = L.geoJSON(featureCollection);
            var layers = layerJson.getLayers();
            if (layers.length == 0) {
                showMsg("绘制区域内无规划用地信息！");
                return;
            }

            var tjObj = {};

            // 处理同一个类别 一种颜色
            var colorObj = {};

            var popup_columns = gisdata.config.popup_columns;
            for (var index = 0; index < layers.length; index++) {
                var layer = layers[index];

                var attr = layer.feature.properties;
                //类别
                var type = $.trim(attr.FS_YDDM);
                if (type == '') type = '其他';

                //统计数据
                if (tjObj[type] == null)
                    tjObj[type] = 0;
                tjObj[type] += attr.Shape_Area * 1000000;


                //地块颜色 
                if (colorObj[type] == null)
                    colorObj[type] = getRandomColor();
                layer.setStyle({
                    color: colorObj[type],
                    weight: 1.5,
                    fillOpacity: 0.5
                });

                //bindPopup
                var inhtml = "";
                for (var i in attr) {
                    var showval = $.trim(attr[i]);
                    if (showval == null || showval == '' || showval == '0' || showval.length == 0) continue;

                    var col = popup_columns[i];
                    if (col == null) col = i;
                    if (!isChinese(col)) continue;

                    if (i == "Shape_Area") {
                        showval = Number(showval);
                        if (showval < 1)
                            showval = (showval * 1000000).toFixed(2) + ' 平方米';
                        else
                            showval = (showval).toFixed(2) + ' 平方千米';
                    }


                    inhtml += col + ":" + showval + "<br/>";
                }
                layer.bindPopup(inhtml);


                $this.layerResult.addLayer(layer);
            }
            fitBounds($this.layerResult.getBounds());

            //对数据进行排序
            var arrObj = [];
            var compare = function (prop) {
                return function (obj1, obj2) {
                    var val1 = obj1[prop];
                    var val2 = obj2[prop];
                    if (val1 < val2) {
                        return -1;
                    } else if (val1 > val2) {
                        return 1;
                    } else {
                        return 0;
                    }
                }
            };
            for (var i in tjObj) {
                var val = Number(tjObj[i].toFixed(2));

                arrObj.push({ name: i, value: val });
            }
            arrObj.sort(compare("value"));



            $this.disable();
            $("#expages").show();

            $this._queryResultLast = arrObj;
            $("#ifrm")[0].contentWindow.queryResult(arrObj);
        });



    }

};