﻿
//============================路线规划================================
var workLXGH = {
    layerWork: null,
    initLayer: function () {
        this.layerWork = L.featureGroup([]).addTo(map);
    },
    clear: function () {
        if (this.layerWork != null)
            this.layerWork.clearLayers();
    },
    hasData: function () {
        if (this.layerWork == null)
            return false;
        return this.layerWork.getLayers().length > 0;
    },
    queryPOI: function (text) {
        //poi arcgcis服务 
        var poiurl = gisdata.config.yhserver.poi_arcgis;
        var query = L.esri.query({
            url: poiurl
        });
        //query.within(map.getBounds());
        query.where("NAME like '%" + text + "%'");
        query.orderBy('YHDB.DBO.poi.LEN', 'ASC');

        query.bounds(function (error, latLngBounds, response) {
            var arrMarkers = [];
            var features = response.features;
            $.each(features, function (index, item) {
                var attributes = item.attributes;

                var newattr = {};
                newattr["name"] = attributes.NAME;
                newattr["jd"] = item.geometry.x;
                newattr["wd"] = item.geometry.y;
                newattr["address"] = attributes.ADDRESS;

                arrMarkers.push(newattr);
            });

            $("#ifrm")[0].contentWindow.poiQueryResult(arrMarkers);

        });
    },

    //添加自驾路线方法
    addRouteCar: function (startMpt, endMpt, arrSteps) {
        var reslutHtml = "<li><a href=\"javascript:void(0);\">" + endMpt.distance + "   " + endMpt.duration + "</a></li>";

        if (this.layerWork == null)
            this.initLayer();

        var layer = this.layerWork;
        layer.clearLayers();

        var routeStartMpt;
        var routeEndMpt;
        $.each(arrSteps, function (index, stepitem) {

            var arrLine = [];
            var mpts = stepitem.polyline.split(';');
            $.each(mpts, function (index, mpt) {
                var temp = mpt.split(',');
                var jd = Number(temp[0]);
                var wd = Number(temp[1]);
                var result = pointconvert.gcj2wgs([jd, wd]);
                var mpt = [result[1], result[0]];
                arrLine.push(mpt);

                if (routeStartMpt == null)
                    routeStartMpt = mpt;
                routeEndMpt = mpt;
            });
            var route = L.polyline(arrLine, { color: 'red', weight: 5 });

            var inHtml = "<b>" + (stepitem.road || '') + "</b> <br>长度：" + formatLength(stepitem.distance) + "<br>说明：" + stepitem.instruction;
            route.bindPopup(inHtml);
            layer.addLayer(route);


            route.index = index;
            reslutHtml += "<li><a href=\"javascript:parent.workLXGH.centerRouteStep(" + index + ");\">" + (index + 1) + "." + stepitem.instruction + "</a></li>";
        });


        var marker;
        //起点
        marker = L.marker([startMpt.wd, startMpt.jd], { icon: iconObj.Instance().start });
        marker.bindPopup("<b>" + startMpt.mc + "</b>");
        layer.addLayer(marker);

        var route = L.polyline([[startMpt.wd, startMpt.jd], routeStartMpt], { color: '#3388ff', dashArray: '5, 10', weight: 5 });
        route.bindPopup("<b>请步行前往</b>");
        layer.addLayer(route);


        //终点  
        var inHtml = "<b>" + endMpt.mc + "</b>"
            //+ "<br/>行驶方案：" + endMpt.strategy 
            + "<br/>行驶距离：" + endMpt.distance
            + "<br/>预计行驶时间：" + endMpt.duration
            + "<br/>道路收费：" + endMpt.tolls
            + "<br/>收费道路长度：" + endMpt.toll_distance
            + "<br/>打车预计费用：" + endMpt.taxi_cost;

        marker = L.marker([endMpt.wd, endMpt.jd], { icon: iconObj.Instance().end });
        marker.bindPopup(inHtml);
        layer.addLayer(marker);

        var route = L.polyline([[endMpt.wd, endMpt.jd], routeEndMpt], { color: '#3388ff', dashArray: '5, 10', weight: 5 });
        route.bindPopup("<b>请步行前往</b>");
        layer.addLayer(route);
 
        fitBounds(layer.getBounds());
        marker.openPopup();

        return reslutHtml;
    },

    //添加公交路线方法
    addRouteBus: function (startMpt, endMpt, arrSteps) {
        var reslutHtml = "<li><a href=\"javascript:void(0);\">" + endMpt.duration + "   " + endMpt.cost + "</a></li>";

        if (this.layerWork == null)
            this.initLayer();

        var layer = this.layerWork;
        layer.clearLayers();


        var indexresult = 1;
        $.each(arrSteps, function (index, stepitem) {

            //步行导航信息列表：walking
            var walkingsteps = stepitem.walking.steps;
            $.each(walkingsteps, function (walkingindex, walkitem) {

                var arrLine = [];
                var mpts = walkitem.polyline.split(';');
                $.each(mpts, function (index, mpt) {
                    var temp = mpt.split(',');
                    var jd = Number(temp[0]);
                    var wd = Number(temp[1]);
                    var result = pointconvert.gcj2wgs([jd, wd]);
                    var mpt = [result[1], result[0]];
                    arrLine.push(mpt);
                });
                var route = L.polyline(arrLine, { color: '#3388ff', dashArray: '5, 10', weight: 5 });

                var inHtml = "<b>" + (walkitem.road || '') + "</b> <br>距离：" + formatLength(walkitem.distance) + "<br>说明：" + walkitem.instruction;
                route.bindPopup(inHtml);
                layer.addLayer(route);

                route.index = indexresult;
                reslutHtml += "<li><a href=\"javascript:parent.workLXGH.centerRouteStep(" + indexresult + ");\">" + (indexresult++) + ".步行:" + walkitem.instruction + "</a></li>";
            });


            //公交导航信息列表：bus
            var bussteps = stepitem.bus.buslines;
            $.each(bussteps, function (busindex, busitem) {

                var arrLine = [];
                var mpts = busitem.polyline.split(';');
                $.each(mpts, function (index, mpt) {
                    var temp = mpt.split(',');
                    var jd = Number(temp[0]);
                    var wd = Number(temp[1]);
                    var result = pointconvert.gcj2wgs([jd, wd]);
                    var mpt = [result[1], result[0]];
                    arrLine.push(mpt);
                });
                var route = L.polyline(arrLine, { color: 'red', weight: 5 });

                var inHtml = "<b>" + (busitem.name || '') + "</b> "
                    + "<br>途经公交站数：" + busitem.via_num + "站"
                    + "<br>行驶距离：" + formatLength(busitem.distance)
                    + "<br>乘车时间：" + formatTime(busitem.duration)
                    + "<br>类型：" + busitem.type;
                route.bindPopup(inHtml);
                layer.addLayer(route);

                route.index = indexresult;
                reslutHtml += "<li><a href=\"javascript:parent.workLXGH.centerRouteStep(" + indexresult + ");\">" + (indexresult++) + ".公交" + busitem.name + "，行驶" + formatLength(busitem.distance) + "，预计" + formatTime(busitem.duration) + "</a></li>";
            });


        });


        var marker;
        //起点
        marker = L.marker([startMpt.wd, startMpt.jd], { icon: iconObj.Instance().start });
        marker.bindPopup("<b>" + startMpt.mc + "</b>");
        layer.addLayer(marker);

        //终点  
        var inHtml = "<b>" + endMpt.mc + "</b>"
            + "<br/>乘车费用：" + endMpt.cost
            + "<br/>预计时间：" + endMpt.duration
            + "<br/>步行距离：" + endMpt.walking_distance
            + "<br/>打车预计费用：" + endMpt.taxi_cost;

        marker = L.marker([endMpt.wd, endMpt.jd], { icon: iconObj.Instance().end });
        marker.bindPopup(inHtml);
        layer.addLayer(marker);


        fitBounds(layer.getBounds());
        marker.openPopup();

        return reslutHtml;
    },

    lastRouteSep: null,
    centerRouteStep: function (index) {
        if (this.lastRouteSep != null) {
            this.lastRouteSep.setStyle({ color: '#ff0000' });
            this.lastRouteSep = null;
        }
        this.layerWork.eachLayer(function (layer) {
            if (layer.index == index) {
                hideExPage();
                fitBounds(layer.getBounds());

                layer.setStyle({ color: '#0000ff' });
                layer.openPopup();
                this.lastRouteSep = layer;
                return;
            }
        });
    }
};
