﻿
//============================测量================================ 

var measureWidget = (function () {
    //单例对象
    var instantiated;
    function init() {
        return {
            plotLayer: null,
            markDotIcon: null,
            LabelIcon: null,
            drawPoly: null,
            create: function () {//初始化
                this.plotLayer = new L.FeatureGroup();
                map.addLayer(this.plotLayer);

                this.markDotIcon = L.icon({
                    iconUrl: 'resources/img/marker/mark-dot.png',
                    iconSize: [16, 16]
                });
                this.LabelIcon = L.Icon.Label.extend({
                    options: {
                        iconUrl: 'resources/lib/leaflet/plugins/iconlabel/img/null.png',
                        shadowUrl: null,
                        iconSize: new L.Point(24, 24),
                        iconAnchor: new L.Point(0, 0),
                        wrapperAnchor: new L.Point(-24, 13),
                        labelAnchor: new L.Point(0, 0),
                        labelClassName: 'leaflet-marker-iconlabel'
                    }
                });
            },
            type: 'length',  //length测量长度，area测量面积 
            isactivate: false,//激活状态 
            activate: function (type) {//激活工具  
                this.isactivate = true;
                hideUIView();
                $("#content_header_tipbar").show();
                $("#tipbar_back").bind("click", this.disable);

                var $tipbarbtn = $("#tipbar_btn");
                $tipbarbtn.html("清除");
                $tipbarbtn.show();
                $tipbarbtn.bind("click", this._reset_draw);

                this.type = type;
                if (this.type == 'length') {
                    $("#tipbar_text").html("距离测量");
                    this.drawPoly = new L.Polyline([]);
                    this.plotLayer.addLayer(this.drawPoly);
                }
                else {
                    $("#tipbar_text").html("面积测量");
                    this.drawPoly = new L.Polygon([]);
                    this.plotLayer.addLayer(this.drawPoly);
                }

                map.on('click', this._onMapClick);
                //map.on('dblclick', this._onMapDoubleClick);
            },
            disable: function () {//关闭释放工具
                var $this = measureWidget.Instance();

                if (!$this.isactivate) return;
                $this.isactivate = false;
                $("#tipbar_back").unbind("click", $this.disable);

                var $tipbarbtn = $("#tipbar_btn");
                $tipbarbtn.hide();
                $tipbarbtn.unbind("click", $this._reset_draw);

                showUIView();
                $("#content_header_tipbar").hide();



                $this.plotLayer.clearLayers();
                map.off('click', $this._onMapClick);
                //map.off('dblclick', $this._onMapDoubleClick);
            },
            _onMapClick: function (e) {
                measureWidget.Instance().updateDraw(e.latlng);
            },
            _onMapDoubleClick: function (e) {
                map.off('click', this._onMapClick);
                //map.off('dblclick', this._onMapDoubleClick);
                measureWidget.Instance().updateDraw(e.latlng);
            },
            updateDraw: function (latlng) {
                var marker = L.marker(latlng, { icon: this.markDotIcon });
                this.plotLayer.addLayer(marker);

                this.drawPoly.addLatLng(latlng);
                this.drawPoly.redraw();

                if (this.type == 'length') {
                    var latlngs = this.drawPoly.getLatLngs();
                    //各线段长度
                    if (latlngs.length > 1) {
                        var arr = [latlngs[latlngs.length - 2], latlngs[latlngs.length - 1]]
                        var length = L.GeometryUtil.lengthstr(arr);
                        var marker = L.marker(latlng, { icon: new this.LabelIcon({ labelText: length }) });
                        this.plotLayer.addLayer(marker);
                    }

                    var length = L.GeometryUtil.lengthstr(latlngs);
                    //this.drawPoly.bindPopup('长度：' + length); 
                    //this.drawPoly.openPopup();
                    $("#tipbar_text").html("距离总长 " + length);
                }
                else {
                    var area = L.GeometryUtil.areastr(this.drawPoly.getLatLngs()[0]);
                    //this.drawPoly.bindPopup('面积：' + area); 
                    //this.drawPoly.openPopup();
                    $("#tipbar_text").html("面积测量 " + area);
                }
            },
            _reset_draw: function () {
                var $this = measureWidget.Instance();

                $this.plotLayer.clearLayers();
                if ($this.type == 'length') {
                    $("#tipbar_text").html("距离测量");
                    $this.drawPoly = new L.Polyline([]);
                    $this.plotLayer.addLayer($this.drawPoly);
                }
                else {
                    $("#tipbar_text").html("面积测量");
                    $this.drawPoly = new L.Polygon([]);
                    $this.plotLayer.addLayer($this.drawPoly);
                }
            }

        };
    }

    return {
        Instance: function () {
            if (!instantiated) {
                instantiated = init();
                instantiated.create();
            }
            return instantiated;
        }
    };
})();
