﻿
//============================poi周边查询================================
var workZBCX = {
    layerWork: null,
    initLayer: function () {
        this.layerWork = L.markerClusterGroup({
            chunkedLoading: true,       //间隔添加数据，以便页面不冻结。
            spiderfyOnMaxZoom: true,    //在地图最底层，不聚合可以看到所有的标记。
            disableClusteringAtZoom: 19 //此级别下不聚合
        }).addTo(map);
        //this.layerWork = L.featureGroup([]).addTo(map); 

        this.layerWork.on('click', function (evt) {
            workZBCX.bindPoiInfo(evt.layer.attributes);
        });
    },
    clear: function () {
        if (this.layerWork)
            this.layerWork.clearLayers();
        this.hidePoiInfo();
    },
    hasData: function () {
        if (this.layerWork == null)
            return false;
        return this.layerWork.getLayers().length > 0;
    },
    //arcgis服务
    queryPOI: function (param, callResponse) {
        this.clear();
        //查询  
        var query = L.esri.query({
            url: gisdata.config.yhserver.poi_arcgis
        });

        if (param.type == "1" && gisdata.location == null)
            param.type = "2";

        switch (param.type) {
            case "1": //当前位置
                if (param.radius > 0) {
                    var circle = L.circle(gisdata.location, { radius: param.radius });
                    map.addLayer(circle);
                    query.within(circle.getBounds());
                    map.removeLayer(circle);
                }
                break;
            case "2": //当前视域内
                query.within(map.getBounds());
                break;
            case "3": //图上选点
                if (param.radius > 0) {
                    var circle = L.circle(param.latlng, { radius: param.radius });
                    map.addLayer(circle);
                    query.within(circle.getBounds());
                    map.removeLayer(circle);
                }
                break;
        }
        query.where("NAME like '%" + param.text + "%'");
        if (param.where != null && param.where.length > 0)
            query.where(param.where);

        query.orderBy('YHDB.DBO.poi.LEN', 'ASC');

        query.bounds(function (error, latLngBounds, response) {
            if (error != null && error.code > 0) {
                showMsg(error.message);
                return;
            }
            var arrMarkers = [];
            var objMarkers = {};
            var features = response.features;
            $.each(features, function (index, item) {
                var attributes = item.attributes;
                //attributes.latlng = yhcrs.unproject(item.geometry);
                attributes.latlng = [item.geometry.y, item.geometry.x];
                arrMarkers.push(attributes);
                objMarkers[attributes.OBJECTID] = attributes;
            });

            callResponse(arrMarkers, objMarkers);
        });
    },
    //arcgis服务
    queryDZ: function (param, callResponse) {
        this.clear();
        //查询  
        var query = L.esri.query({
            url: gisdata.config.yhserver.dz_arcgis
        });

        if (param.type == "1" && gisdata.location == null)
            param.type = "2";

        switch (param.type) {
            case "1": //当前位置
                if (param.radius > 0) {
                    var circle = L.circle(gisdata.location, { radius: param.radius });
                    map.addLayer(circle);
                    query.within(circle.getBounds());
                    map.removeLayer(circle);
                }
                break;
            case "2": //当前视域内
                query.within(map.getBounds());
                break;
            case "3": //图上选点
                if (param.radius > 0) {
                    var circle = L.circle(param.latlng, { radius: param.radius });
                    map.addLayer(circle);
                    query.within(circle.getBounds());
                    map.removeLayer(circle);
                }
                break;
        }
        query.where("addname like '%" + param.text + "%'");
        if (param.where != null && param.where.length > 0)
            query.where(param.where);

        query.orderBy('region', 'ASC');

        query.bounds(function (error, latLngBounds, response) {
            if (error != null && error.code > 0) {
                showMsg(error.message);
                return;
            }
            var arrMarkers = [];
            var objMarkers = {};
            var features = response.features;
            $.each(features, function (index, item) {
                var attributes = item.attributes;
                attributes.latlng = [item.geometry.y, item.geometry.x];

                attributes["NAME"] = attributes["addname"];
                attributes["ADDRESS"] = attributes["town"] + attributes["community"] + attributes["street"] + attributes["region"];

                attributes["PHONE"] = "";//attributes["coltime"];

                arrMarkers.push(attributes);
                objMarkers[attributes.OBJECTID] = attributes;
            });

            callResponse(arrMarkers, objMarkers);
        });
    },
    showPOIArr: function (arr) {
        if (this.layerWork == null)
            this.initLayer();

        $.each(arr, function (index, item) {
            workZBCX.showPOI(item, false);
        });
        fitBounds(this.layerWork.getBounds());
    },
    showPOI: function (attributes, iscenter) {
        if (this.layerWork == null)
            this.initLayer();

        var marker = L.marker(attributes.latlng, { icon: iconObj.Instance().poi });
        marker.attributes = attributes;
        this.layerWork.addLayer(marker);
        if (iscenter) {
            var level = map.getZoom();
            if (level < gisdata.centerAutoLevel && map.getMaxZoom() >= gisdata.centerAutoLevel) {
                level = gisdata.centerAutoLevel;
            }

            map.stop();
            map.setView(attributes.latlng, level);

            this.bindPoiInfo(attributes);
        }
        return marker;
    },
    _poidata: null,
    hidePoiInfo: function () {
        $("#content_footer_round").hide();
        $("#content_footer").show();
    },
    bindPoiInfo: function (attributes) {
        this._poidata = attributes;
        $("#content_footer").hide();
        $("#content_footer_round").show();

        $("#round_name").html(attributes.NAME);
        $("#round_address").html(attributes.ADDRESS + '  ' + attributes.PHONE);
        var length = L.GeometryUtil.lengthstr([gisdata.location, attributes.latlng]);
        $("#round_length").html(length);
    },
    //到这去
    getPoiInfoLX: function () {
        var _jwd = this._poidata.latlng[1] + "," + this._poidata.latlng[0];
        var _url = encodeURI('pages/route.html?jwd=' + _jwd + '&name=' + this._poidata.NAME);
        showExPage(_url);
    },
    //搜周边
    getPoiInfoZB: function () {
        var _url = encodeURI('pages/roundtype.html?jd=' + this._poidata.latlng[1] + "&wd=" + this._poidata.latlng[0] + '&name=' + this._poidata.NAME);
        showExPage(_url);
    },
    //导航
    getPoiInfoDH: function () {
        var dst = this._poidata.latlng;                                 // 导航目的地坐标
        var src = [parent.gisdata.location.lat, gisdata.location.lng];  // 导航起始地描述 
        openSysMap(dst, this._poidata.NAME, src);
    }
}