L.CRS.EPSG4490 = new L.Proj.CRS('EPSG:4490', '+proj=longlat +ellps=GRS80 +no_defs', {
    resolutions: [
        1.40625, 0.703125, 0.3515625, 0.17578125, 0.087890625,
        0.0439453125, 0.02197265625, 0.010986328125, 0.0054931640625, 0.00274658203125, 0.001373291015625,
        6.866455206208891E-4, 3.4332276031044456E-4, 1.7166138015522228E-4,
        8.583069007761114E-5, 4.291534503880557E-5,
        2.1457672519402785E-5, 1.0728836259701392E-5, 5.364418129850696E-6,
        2.682209064925349E-6, 1.3411045324626745E-6],
    origin: [-180, 90],
    bounds: L.bounds([-180, -90], [180, 90])
});


L.TileLayer.TDT = L.TileLayer.extend({
    layername: "vec", 
    initialize: function (url, options) {
        options = options || {}; 
        this.layername = options.layer || this.layername;
        L.setOptions(this, options);
    },
    getTileUrl: function (tilePoint) {

        var row = tilePoint.y;
        var col = tilePoint.x;
        var level = tilePoint.z;

        var h = parseInt(Math.random() * 7);
        var baseUrl = "http://t" + h + ".tianditu.com/" + this.layername + "_c/wmts";

        var url = baseUrl + "?Service=WMTS&Request=GetTile&Version=1.0.0" +
                "&Style=Default&Format=tiles&serviceMode=KVP&layer=" + this.layername +
                "&TileMatrixSet=c&TileMatrix=" + level + "&TileRow=" + row + "&TileCol=" + col;
        return url;
    }
});


//vec,cva,img,cia
L.tileLayer.tdt = function (options) {
    return new L.TileLayer.TDT(null, options);
 }; 